import 'package:iroute/iroute.dart';
import 'package:flutter/material.dart';

class IRouteAppShell extends StatefulWidget {
  IRouteAppShell({required this.pageList, required this.routes});
  final PageList pageList;
  final Map<String, RouteBuilder> routes;
  @override
  IRouteAppShellState createState() =>
      IRouteAppShellState(pageList: pageList, routes: routes);
}

class IRouteAppShellState extends State {
  IRouteAppShellState({required this.pageList, required this.routes})
      : _routerDelegate = IRoute(routes: routes);

  IRouteRoot? root;
  final IRoute _routerDelegate;
  final PageList pageList;
  final Map<String, RouteBuilder> routes;
  ChildBackButtonDispatcher? _backButtonDispatcher;
  int _index = 0;

  @override
  void initState() {
    super.initState();
  }

  @override
  void didUpdateWidget(covariant IRouteAppShell oldWidget) {
    super.didUpdateWidget(oldWidget);
  }

  @override
  void didChangeDependencies() {
    super.didChangeDependencies();
    _backButtonDispatcher = Router.of(context)
        .backButtonDispatcher!
        .createChildBackButtonDispatcher();
  }

  @override
  Widget build(BuildContext context) {
    _backButtonDispatcher!.takePriority();
    if (root == null) {
      root = IRouteRoot.of(context);
      _routerDelegate.root = root;
      _routerDelegate.pageList = (widget as IRouteAppShell).pageList;
      _routerDelegate.addListener(() {
        _index = _routerDelegate.selectedPage;
        setState(() => {});
      });
    }
    List<BottomNavigationBarItem> items = [];
    pageList.pages.forEach((element) {
      items.add(element.bottom);
    });

    return Scaffold(
      body: Router(
        routerDelegate: _routerDelegate,
        backButtonDispatcher: _backButtonDispatcher,
      ),
      bottomNavigationBar: BottomNavigationBar(
        items: items,
        currentIndex: _index,
        onTap: (newIndex) {
          _routerDelegate.selectedPage = newIndex;
        },
      ),
    );
  }
}
